package com.goodpetting;

import java.sql.*;

/* connectBean.java  
	make and maintain a database connection for the administrator
 * 
 * @author Evan Johnson & William Hosbein
 * @version 5-27-04
 */

public class adminConnect
{
	
	private static final String connectionURL = "jdbc:mysql://localhost:3306/store1";
	private static final String dbUsername = "store1admin";
	private static final String dbPassword = "store1admin";
	private String lastError;
	private boolean isConnected = false;
	
	private Connection connection = null;

	public adminConnect()
	{
		try
		{
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			try
			{
				connection = DriverManager.getConnection(connectionURL, dbUsername, dbPassword);
				isConnected = true;
			}
			catch( SQLException sqle )
			{
				lastError = "Error connecting to database: " + sqle;
			} 
		}
		catch (ClassNotFoundException err)
		{
			lastError = "Class loading error. (NotFound)";
		}
		catch (InstantiationException err2)
		{
			lastError = "Class loading error. (InstantiationException)";
		}
		catch (IllegalAccessException err3)
		{
			lastError = "Class loading error. (IllegalAccessException)";
		}
	}
	
	public void disconnect() throws SQLException
	{
		connection.close();
	}

	public ResultSet makeQuery (String sql) throws SQLException
	{
		Statement statement = null;
		ResultSet resultset = null;
		statement = connection.createStatement();
		resultset = statement.executeQuery(sql);
		return resultset;
	}

	public void execStatement (String sql) throws SQLException
	{
		Statement statement = null;
		statement = connection.createStatement();
		statement.executeUpdate(sql);
	}
	
	public boolean isConnected()
	{
		return isConnected;
	}

}