package com.goodpetting;

 import java.util.Vector;
import java.util.Iterator;
/**
 * The shopping cart, basically an array (vector) of "item" classes.
 * 
 * 
 * @author Evan Johnson & William Hosbein
 * @version 5-27-04
 */
public class shoppingCart
{
	//learn how to serialize the result sets and make and array of those?
	private String user;			//which user owns this bean
	private Vector<item> contents;	//the contents of the cart
	private double total;			//current total in cart
	private int numItems;			//total number of itmes in the cart (not distinct items, but total)

	public shoppingCart()
	{
		user = "default user";
		contents = new Vector<item>();
		total = 0.0;
		numItems = 0;
	}

	//set the user
	public void setUser(String u)
	{
		user = u;
    }

	//get the username
	public String getUser()
	{
		return user;
    }
	
	//add "quant" number of "name" items to the cart, and record the price of each item
	public void addItems(String name, int quant, double price)
	{
		contents.add(new item(name, quant, price));
		numItems += quant;
	}

	//this checks to see if the item "name" is already in the cart
	public boolean alreadyInCart(String name)
	{
		boolean isThere = false;
		Iterator iter = contents.iterator();
		while (iter.hasNext())					//while there's another item
		{
			item tempItem = (item) iter.next();
			if (name.equals((String) tempItem.getName()))	//see if it's already in the array
			{
				isThere = true;
				break;
    		}
    	}
		return isThere;
	}

	//updates the "quant" of item "name" - if quant is zero, it removes the item from the vector
	public void setQuant(String name, int quant)
	{
		Iterator iter = contents.iterator();
		while (iter.hasNext())
		{
			item tempItem = (item) iter.next();
			if (name.equals((String) tempItem.getName()))
			{
				if(quant == 0)						//if zero
				{
					numItems -= tempItem.getQuantity();
					iter.remove();					//remove this from the vector
    			}
				else
				{
					numItems -= tempItem.getQuantity();		//otherwise just change the quantity
					tempItem.updateQuantity(quant);
					numItems += quant;
    				}
    			}
    		}
	}

	//the empties the cart totally
	public void emptyCart ()
	{
		numItems = 0;
		Iterator iter = contents.iterator();
		while (iter.hasNext())					//for each item
		{
			iter.next();
			iter.remove();					//delete it from the cart vector
    		}
	}
	
	//ruturns the content vector in it's entirety
	public Vector getContents()
	{
		return contents;		//return the whole vector
	}

	//returns the total number of items in the cart
	public int getItems()
	{
		return numItems;		//get the number items (displayed at top of user pages)
	}

	//gets the number of item "name" that are in the cart
	public int getQuant(String name)
	{
		Iterator iter = contents.iterator();
		while (iter.hasNext())
		{
			item tempItem = (item) iter.next();
			if (name.equals((String) tempItem.getName()))
			{
				return tempItem.getQuantity();		//useful for stock calculations and cart additions
    		}
    	}
		return 0;
	}
}